



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++的拷贝构造函数、operator=运算符重载，深拷贝和浅拷贝、explicit关键字</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++的拷贝构造函数、operator=运算符重载，深拷贝和浅拷贝、explicit关键字</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:16:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文地址：https://blog.csdn.net/shine_journey/article/details/53081523</p>
<p>1、在C++编码过程中，类的创建十分频繁。</p>
<p>简单的功能，当然不用考虑太多，但是从进一步深刻理解C++的内涵，类的结构和用法，编写更好的代码的角度去考虑，我们就需要用到标题所提到的这些内容。</p>
<p>2、先上代码</p>
<div>
<ol><li>//&nbsp;testSingleMode.cpp&nbsp;:&nbsp;定义控制台应用程序的入口点。</li>
<li>//</li>
<li>#include&nbsp;"stdafx.h"</li>
<li>#include&nbsp;&lt;iostream&gt;</li>
<li>using&nbsp;namespace&nbsp;std;</li>
<li>class&nbsp;Complex</li>
<li>{</li>
<li>private:</li>
<li>double&nbsp;m_real;</li>
<li>double&nbsp;m_imag;</li>
<li>public:</li>
<li>Complex(void){</li>
<li>m_real&nbsp;=&nbsp;0.0;</li>
<li>m_imag&nbsp;=&nbsp;0.0;</li>
<li>}</li>
<li>Complex(double&nbsp;real,&nbsp;double&nbsp;imag){</li>
<li>m_real&nbsp;=&nbsp;real;</li>
<li>m_imag&nbsp;=&nbsp;imag;</li>
<li>}</li>
<li>Complex(const&nbsp;Complex&nbsp;&amp;&nbsp;c){&nbsp;//这里就是最经典的拷贝构造函数了</li>
<li>m_real&nbsp;=&nbsp;c.m_real;</li>
<li>m_imag&nbsp;=&nbsp;c.m_imag;</li>
<li>}</li>
<li>Complex&nbsp;&amp;operator&nbsp;=&nbsp;(const&nbsp;Complex&nbsp;&amp;rhs){&nbsp;&nbsp;&nbsp;//这里就是最经典的operator=操作符重载了</li>
<li>if&nbsp;(this&nbsp;==&nbsp;&amp;rhs){</li>
<li>return&nbsp;*this;</li>
<li>}</li>
<li>this-&gt;m_real&nbsp;=&nbsp;rhs.m_real;</li>
<li>this-&gt;m_imag&nbsp;=&nbsp;rhs.m_imag;</li>
<li>return&nbsp;*this;</li>
<li>}</li>
<li>explicit&nbsp;Complex::Complex(double&nbsp;r){&nbsp;&nbsp;&nbsp;&nbsp;//explicit的用法，只适用于1个参数的情况</li>
<li>m_real&nbsp;=&nbsp;r;</li>
<li>m_imag&nbsp;=&nbsp;0.0;</li>
<li>}</li>
<li>};</li>
<li>int&nbsp;main()</li>
<li>{</li>
<li>Complex&nbsp;c1,&nbsp;c2;&nbsp;//调用&nbsp;第15行&nbsp;默认无参数的构造函数</li>
<li>Complex&nbsp;c3(1.0,&nbsp;2.5);&nbsp;&nbsp;&nbsp;//调用&nbsp;第20行&nbsp;具有2个形参的构造函数</li>
<li>//Complex&nbsp;c3&nbsp;=&nbsp;Complex(1.0,&nbsp;2.5);&nbsp;&nbsp;&nbsp;//和上一行是一个意思，所以这个注释了</li>
<li>c1&nbsp;=&nbsp;c3;&nbsp;&nbsp;&nbsp;&nbsp;//调用&nbsp;第30行&nbsp;重载operator=运算符</li>
<li>c2&nbsp;=&nbsp;c3;&nbsp;&nbsp;&nbsp;&nbsp;//调用&nbsp;第30行&nbsp;重载operator=运算符</li>
<li>//c2&nbsp;=&nbsp;5.2;&nbsp;//隐式转换，需要去掉41行的explicit关键字，才可编译通过</li>
<li>Complex&nbsp;c5(c2);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//调用&nbsp;第25行&nbsp;拷贝构造函数</li>
<li>Complex&nbsp;c4&nbsp;=&nbsp;c2;&nbsp;&nbsp;&nbsp;&nbsp;//调用&nbsp;第25行&nbsp;拷贝构造函数</li>
<li>getchar();</li>
<li>return&nbsp;0;</li>
<li>}</li></ol>
</div>
<p>【注1】explicit&nbsp;只适用于构造函数只含有1个参数的情况，加上这个关键字，意味着不支持构造函数隐式转换，可以避免一些误解。如果去掉这个关键字，那么代码里面的：c2 = 5.2 ; 就是可以执行的了。</p>
<p>【注2】为什么函数中可以直接访问对象c的私有成员？<br>答：（网上）因为拷贝构造函数是放在本身这个类里的，而类中的函数可以访问这个类的对象的所有成员，当然包括私有成员了。</p>
<p>3、上面代码的注释，已经是非常的清楚了</p>
<p>自定义拷贝构造函数是一种良好的编程风格，它可以阻止编译器形成默认的拷贝构造函数，防止出错。</p>
<p>浅拷贝：如果自己不写拷贝构造函数，系统会默认生成一个，而系统的拷贝构造函数是浅拷贝。</p>
<p>深拷贝：自己写一个拷贝构造函数，系统就不会产生了默认的构造函数了（来自网上说法）。自己写的这个拷贝构造函数，当然会有开辟空间的动作，所以是深拷贝。也就是说，如果生成类的实例的时候，调用了自己写的拷贝构造函数，那么在内存空间上，必然是会开辟新的空间，而不用担心只是一个指针。</p>
<p>在某些状况下，类内成员变量需要动态开辟堆内存，如果实行浅拷贝，也就是把对象里的值完全复制给另一个对象，如A=B。这时，如果B中有一个成员变量指针已经申请了内存，那A中的那个成员变量也指向同一块内存。这就出现了问题：当B把内存释放了（如：析构），这时A内的指针就是野指针了，出现运行错误。</p>
<p>4、总结</p>
<p>（1）深拷贝：如果一个类拥有资源，当这个类的对象发生复制过程的时候，资源重新分配，这个过程就是深拷贝。反之，没有重新分配资源，就是浅拷贝。</p>
<p>（2）什么时候用到拷贝构造函数</p>
<div>&nbsp; a.一个对象以值传递的方式传入函数体；&nbsp;<br>&nbsp;&nbsp;b.一个对象以值传递的方式从函数返回；</div>
<div>&nbsp;&nbsp;c.一个对象需要通过另外一个对象进行初始化。</div>
<p>（4）代码例子</p>
<div>
<ol><li>#include&nbsp;"stdafx.h"</li>
<li>#include&nbsp;&lt;iostream&gt;</li>
<li>#include&nbsp;&lt;string.h&gt;</li>
<li>#include&nbsp;&lt;stdio.h&gt;</li>
<li>#include&nbsp;&lt;stdlib.h&gt;</li>
<li>using&nbsp;namespace&nbsp;std;</li>
<li>class&nbsp;Person</li>
<li>{</li>
<li>public:</li>
<li>//&nbsp;构造函数</li>
<li>Person(char&nbsp;*&nbsp;pN)</li>
<li>{</li>
<li>cout&nbsp;&lt;&lt;&nbsp;"一般构造函数被调用&nbsp;!\n";</li>
<li>m_pName&nbsp;=&nbsp;new&nbsp;char[strlen(pN)&nbsp;+&nbsp;1];</li>
<li>//在堆中开辟一个内存块存放pN所指的字符串</li>
<li>if&nbsp;(m_pName&nbsp;!=&nbsp;NULL)</li>
<li>{</li>
<li>//如果m_pName不是空指针，则把形参指针pN所指的字符串复制给它</li>
<li>strcpy_s(m_pName,&nbsp;strlen(pN)&nbsp;+&nbsp;1,&nbsp;pN);</li>
<li>}</li>
<li>}</li>
<li>//&nbsp;下面自己设计复制构造函数，实现“深拷贝”，即不让指针指向同一地址，而是重新申请一块内存给新的对象的指针数据成员</li>
<li>Person(Person&nbsp;&amp;&nbsp;chs)</li>
<li>{</li>
<li>cout&nbsp;&lt;&lt;&nbsp;"拷贝构造函数被调用&nbsp;!\n";</li>
<li>//&nbsp;用运算符new为新对象的指针数据成员分配空间</li>
<li>m_pName&nbsp;=&nbsp;new&nbsp;char[strlen(chs.m_pName)&nbsp;+&nbsp;1];</li>
<li>if&nbsp;(m_pName)</li>
<li>{</li>
<li>//&nbsp;复制内容</li>
<li>strcpy_s(m_pName,&nbsp;strlen(chs.m_pName)&nbsp;+&nbsp;1,&nbsp;chs.m_pName);</li>
<li>}</li>
<li>//&nbsp;则新创建的对象的m_pName与原对象chs的m_pName不再指向同一地址了</li>
<li>}</li>
<li>////&nbsp;系统创建的默认复制构造函数，只做位模式拷贝</li>
<li>//Person(Person&nbsp;&amp;&nbsp;p)</li>
<li>//{</li>
<li>//&nbsp;&nbsp;//使两个字符串指针指向同一地址位置</li>
<li>//&nbsp;&nbsp;m_pName&nbsp;=&nbsp;p.m_pName;</li>
<li>//}</li>
<li>~Person()</li>
<li>{</li>
<li>delete&nbsp;m_pName;</li>
<li>}</li>
<li>void&nbsp;getName(){</li>
<li>cout&nbsp;&lt;&lt;&nbsp;m_pName&nbsp;&lt;&lt;&nbsp;endl;</li>
<li>}</li>
<li>private:</li>
<li>char&nbsp;*&nbsp;m_pName;</li>
<li>};</li>
<li>void&nbsp;main()</li>
<li>{</li>
<li>Person&nbsp;man("lujun");</li>
<li>man.getName();</li>
<li>Person&nbsp;woman(man);</li>
<li>woman.getName();</li>
<li>getchar();</li>
<li>}</li></ol>
</div>
<p>程序运行环境： VS2013</p>
<p>输出结果：</p>
<p><img referrerpolicy="no-referrer"src="https://img-blog.csdn.net/20161108143731660"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r33m90.html">PHP 面向对象编程和设计模式 &lpar;5&sol;5&rpar; - PHP 命名空间的使用及名称解析规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m4vzp8.html">Leetcode&colon; Can I Win</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykl6j9.html">Node&period;js之绝对选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd120gq.html">TCP协议三次握手过程分析【图解，简单清晰】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydym0mq.html">Linux学习小结（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok317l9.html">去掉VC2010 编辑器里出现的红色波浪线</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydxj22q.html">11&period;编写一个Java程序，计算半径为3&period;0的圆周长和面积并输出结果。把圆周率&pi;定义为常量，半径定义为变量，然后进行计算并输出结果。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k134jr9.html">MyBatis使用DEMO及cache的使用心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyle5j9.html">python循环for，range&comma;xrange；while</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjx73k8.html">Eureka配置instanceId显示IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yzljr8.html">Linux C Socket简单实例与详细注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11ojxq.html">strace命令用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1exl49.html">Jira的搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o41xnlq.html">IIS写权限漏洞 &lpar;HTTP PUT方法利用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pprv0q.html">在Android中，px&comma;dp&comma;dip&comma;sp的不同之处</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4dxnlq.html">SQL SERVER错误代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pd3keq.html">【转】Bri&amp;&num;39&semi;s改装笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd1lv1q.html">css3动画（animation）效果2-旋转的星球</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndvppx8.html">IIS 7 启用 gzip 静态压缩 压缩js和css文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3jnwlq.html">GitHub &amp;amp&semi; Git 基础 （YouTube中文翻译版）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojr745q.html">Unity插件 - MeshEditor（三） 面片破碎&amp;amp&semi;网格破碎</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmkpr8.html">C语言中，&num;include &amp;lt&semi;&amp;gt&semi;和&num;include &amp;quot&semi;&amp;quot&semi;的区别和注意点</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdoj249.html">UIView、UIViewLayout&amp;amp&semi;nbsp&semi;UI&lowbar;01</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1m2dyq.html">（二十五）键盘的设置与TextField细节处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgr5lm8.html">linux进程管理之进程创建</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mx2048.html">网站论坛同步用户，整合api，实现&hellip;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k6v009.html">infiniDB的论坛</a>
			</li>
						<li><a href="https://www.batexi.com/a/950kpzm8.html">对FMDB的封装JRDB</a>
			</li>
						<li><a href="https://www.batexi.com/a/950km068.html">MTK Android software Tools工具的说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k6jkz9.html">Android群英传笔记&mdash;&mdash;第五章：Android Scroll分析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
